package com.hzya.frame.voucher.ae.comf.bd.utils;

import com.hzya.frame.voucher.ae.comf.bd.entity.AccsubjTreeNode;
import com.hzya.frame.voucher.ae.comf.bd.entity.AeConfBdAccsubjEntity;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by zydd on 2025-06-05 17:52
 */
public class AccsubjTreeBuilder {

    public static List<AccsubjTreeNode> buildTree(List<AeConfBdAccsubjEntity> list) {
        List<AccsubjTreeNode> rootNodes = new ArrayList<>();
        int index = 0;

        while (index < list.size()) {
            AeConfBdAccsubjEntity current = list.get(index);

            if (current.getSubjlev() == 1) {
                AccsubjTreeNode node = new AccsubjTreeNode();
                node.setData(current);
                index++;

                // 构建该一级节点下的子树
                node.setChildren(buildChildren(list, index, 1));
                rootNodes.add(node);
            } else {
                // 如果第一个不是一级节点，跳过
                index++;
            }
        }

        return rootNodes;
    }

    // 递归构建子节点
    private static List<AccsubjTreeNode> buildChildren(List<AeConfBdAccsubjEntity> list, int startIndex, int parentLevel) {
        List<AccsubjTreeNode> children = new ArrayList<>();
        int index = startIndex;

        while (index < list.size()) {
            AeConfBdAccsubjEntity current = list.get(index);
            int currentLevel = Math.toIntExact(current.getSubjlev());

            if (currentLevel == parentLevel + 1) {
                // 当前是父级的直接下级
                AccsubjTreeNode node = new AccsubjTreeNode();
                node.setData(current);
                index++;

                // 递归构建其子节点
                node.setChildren(buildChildren(list, index, parentLevel + 1));
                children.add(node);
            } else if (currentLevel <= parentLevel) {
                // 当前等级小于等于父级，说明当前分支结束
                break;
            } else {
                // 跳过非法层级（如从1跳到3）
                index++;
            }
        }

        return children;
    }
}