package com.hzya.frame.voucher.ae.comf.factor.service.impl;

import cn.hutool.core.lang.Assert;
import cn.hutool.json.JSONUtil;
import com.hzya.frame.voucher.ae.comf.factor.entity.AeConfInfluenceFactorCorrelationEntity;
import com.hzya.frame.voucher.ae.comf.factor.dao.IAeConfInfluenceFactorCorrelationDao;
import com.hzya.frame.voucher.ae.comf.factor.service.IAeConfInfluenceFactorCorrelationService;
import org.springframework.stereotype.Service;
import org.springframework.beans.factory.annotation.Autowired;


import com.hzya.frame.basedao.service.impl.BaseService;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 会计事项(accounting_event)-配置-影响因素关联设置(AeConfInfluenceFactorCorrelation)表服务实现类
 *
 * @author zydd
 * @since 2025-05-27 09:07:42
 */
@Service
public class AeConfInfluenceFactorCorrelationServiceImpl extends BaseService<AeConfInfluenceFactorCorrelationEntity, String> implements IAeConfInfluenceFactorCorrelationService {

    private IAeConfInfluenceFactorCorrelationDao aeConfInfluenceFactorCorrelationDao;

    @Autowired
    public void setAeConfInfluenceFactorCorrelationDao(IAeConfInfluenceFactorCorrelationDao dao) {
        this.aeConfInfluenceFactorCorrelationDao = dao;
        this.dao = dao;
    }

    @Override
    public List<AeConfInfluenceFactorCorrelationEntity> queryAll(AeConfInfluenceFactorCorrelationEntity entity) {
        List<AeConfInfluenceFactorCorrelationEntity> query = aeConfInfluenceFactorCorrelationDao.query(entity);
        return query;
    }

    @Override
    public List<AeConfInfluenceFactorCorrelationEntity> queryByMdmId(AeConfInfluenceFactorCorrelationEntity entity) {
        Assert.notNull(entity.getMdmId(), "查询影响因素关联时，主数据id不能为空！");
        List<AeConfInfluenceFactorCorrelationEntity> query = aeConfInfluenceFactorCorrelationDao.query(entity);
        return query;
    }

    @Override
    public List<AeConfInfluenceFactorCorrelationEntity> saveList(List<AeConfInfluenceFactorCorrelationEntity> list) {
        if (list.size() == 0) {
            Assert.state(false, "影响因素关联时保存时，数据不能为空，请检查！");
        }
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            Assert.notNull(factorCorrelation.getMdmId(), "影响因素关联保存时，主数据id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMdmCode(), "影响因素关联保存时，主数据code不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMdmName(), "影响因素关联保存时，主数据name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getFactorId(), "影响因素关联保存时，影响因素id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getFactorName(), "影响因素关联保存时，影响因素name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldId(), "影响因素关联保存时，映射字段id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldCode(), "影响因素关联保存时，映射字段code不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldName(), "影响因素关联保存时，映射字段name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
        }
        List<AeConfInfluenceFactorCorrelationEntity> saveList = new ArrayList<>();
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            AeConfInfluenceFactorCorrelationEntity save = aeConfInfluenceFactorCorrelationDao.save(factorCorrelation);
            saveList.add(save);
        }
        return saveList;
    }

    @Override
    public List<AeConfInfluenceFactorCorrelationEntity> updateList(List<AeConfInfluenceFactorCorrelationEntity> list) {
        if (list.size() == 0) {
            Assert.state(false, "影响因素关联时更新时，数据不能为空，请检查！");
        }
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            Assert.notNull(factorCorrelation.getId(), "影响因素关联保存时，因素关联id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMdmId(), "影响因素关联保存时，主数据id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMdmCode(), "影响因素关联保存时，主数据code不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMdmName(), "影响因素关联保存时，主数据name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getFactorId(), "影响因素关联保存时，影响因素id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getFactorName(), "影响因素关联保存时，影响因素name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldId(), "影响因素关联保存时，映射字段id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldCode(), "影响因素关联保存时，映射字段code不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
            Assert.notNull(factorCorrelation.getMappingFieldName(), "影响因素关联保存时，映射字段name不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
        }
        List<AeConfInfluenceFactorCorrelationEntity> updateList = new ArrayList<>();
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            AeConfInfluenceFactorCorrelationEntity save = aeConfInfluenceFactorCorrelationDao.update(factorCorrelation);
            updateList.add(save);
        }
        return updateList;
    }

    @Override
    public Map<String, Integer> deleteList(List<AeConfInfluenceFactorCorrelationEntity> list) {
        if (list.size() == 0) {
            Assert.state(false, "影响因素关联删除时，数据不能为空，请检查！");
        }
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            Assert.notNull(factorCorrelation.getId(), "影响因素关联删除时，因素关联id不能为空！检验数据为：{}", JSONUtil.toJsonStr(factorCorrelation));
        }
        Map<String, Integer> deleteMap = new HashMap<>();
        for (AeConfInfluenceFactorCorrelationEntity factorCorrelation : list) {
            int i = aeConfInfluenceFactorCorrelationDao.logicRemove(factorCorrelation);
            deleteMap.put(factorCorrelation.getId(), i);
        }
        return deleteMap;
    }
}
