package com.hzya.frame.voucher.ae.comf.module.controller;

import cn.hutool.core.lang.Assert;
import com.github.pagehelper.PageInfo;
import com.hzya.frame.page.PageAttribute;
import com.hzya.frame.voucher.ae.comf.module.entity.AeConfBusinessModuleEntity;
import com.hzya.frame.voucher.ae.comf.module.service.IAeConfBusinessModuleService;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * Created by zydd on 2025-05-22 14:49
 */
@RestController
@RequestMapping("/ae/conf/businessModule")
public class BusinessModuleController extends DefaultController {

    @Autowired
    private IAeConfBusinessModuleService aeConfBusinessModuleService;

    @RequestMapping(value = "/queryPaged", method = RequestMethod.POST)
    public JsonResultEntity queryPaged(@RequestBody AeConfBusinessModuleEntity entity) {
        try {
            PageInfo pageInfo = aeConfBusinessModuleService.queryEntityPaged(entity);
            return getSuccessMessageEntity("请求成功",pageInfo);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/queryAll", method = RequestMethod.POST)
    public JsonResultEntity queryAll() {
        try {
            List<AeConfBusinessModuleEntity> all = aeConfBusinessModuleService.getAll();
            return getSuccessMessageEntity("请求成功",all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    @RequestMapping(value = "/queryById", method = RequestMethod.POST)
    public JsonResultEntity queryById(@RequestBody AeConfBusinessModuleEntity entity) {
        try {
            AeConfBusinessModuleEntity aeConfBusinessModuleEntity = aeConfBusinessModuleService.queryById(entity);
            return getSuccessMessageEntity("请求成功",aeConfBusinessModuleEntity);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    @RequestMapping(value = "/save", method = RequestMethod.POST)
    public JsonResultEntity save(@RequestBody AeConfBusinessModuleEntity entity) {
        try {
            AeConfBusinessModuleEntity save = aeConfBusinessModuleService.save(entity);
            return getSuccessMessageEntity("请求成功",save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public JsonResultEntity update(@RequestBody AeConfBusinessModuleEntity entity) {
        try {
            Assert.notNull(entity.getId(),"更新时，id不能为空");
            AeConfBusinessModuleEntity save = aeConfBusinessModuleService.update(entity);
            return getSuccessMessageEntity("请求成功",save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/delete", method = RequestMethod.POST)
    public JsonResultEntity delete(@RequestBody AeConfBusinessModuleEntity entity) {
        try {
            Assert.notNull(entity.getId(),"删除时，id不能为空");
            int i = aeConfBusinessModuleService.logicRemove(entity);
            return getSuccessMessageEntity("请求成功",null);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }


}
