package com.hzya.frame.voucher.ae.comf.module.service.impl;

import cn.hutool.core.lang.Assert;
import com.hzya.frame.mdm.mdmModuleDb.dao.IMdmModuleDbDao;
import com.hzya.frame.mdm.mdmModuleDb.entity.MdmModuleDbEntity;
import com.hzya.frame.mdm.mdmModuleDbFileds.dao.IMdmModuleDbFiledsDao;
import com.hzya.frame.mdm.mdmModuleDbFileds.entity.MdmModuleDbFiledsEntity;
import com.hzya.frame.mdm.mdmModuleDbFiledsRule.dao.IMdmModuleDbFiledsRuleDao;
import com.hzya.frame.voucher.ae.comf.module.service.IMdmService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by zydd on 2025-05-27 15:06
 */
@Service
public class MdmServiceImpl implements IMdmService {

    @Autowired
    private IMdmModuleDbDao mdmModuleDbDao;
    @Autowired
    private IMdmModuleDbFiledsDao mdmModuleDbFiledsDao;
    @Autowired
    private IMdmModuleDbFiledsRuleDao mdmModuleDbFiledsRuleDao;


    //根据单据id查询表以及相关字段
    @Override
    public List<MdmModuleDbEntity> queryMdmAndFiledsByMdmId(MdmModuleDbEntity entity) {
        Assert.notNull(entity.getMdmId(),"根据");
        List<MdmModuleDbEntity> res=new ArrayList<>();
        //查询单据
        List<MdmModuleDbEntity> mdmModuleDbEntityList = mdmModuleDbDao.query(entity);
        //查询字段,1、主表 2、明细 3、操作日志 4、下发日志
        for (MdmModuleDbEntity mdmModuleDbEntity : mdmModuleDbEntityList) {
            if("3".equals(mdmModuleDbEntity.getDbType())||"4".equals(mdmModuleDbEntity.getDbType())){
                continue;
            }
            MdmModuleDbFiledsEntity mdmModuleDbFiledsEntity = new MdmModuleDbFiledsEntity();
            mdmModuleDbFiledsEntity.setDbId(mdmModuleDbEntity.getId());
            List<MdmModuleDbFiledsEntity> filedList = mdmModuleDbFiledsDao.query(mdmModuleDbFiledsEntity);
            mdmModuleDbEntity.setSublistMdmModuleDbFileds(filedList);
            res.add(mdmModuleDbEntity);
        }

        return res;
    }
}
