package com.hzya.frame.voucher.ae.comf.subject.controller;

import com.hzya.frame.voucher.ae.comf.subject.entity.AeConfSubjectContrastBEntity;
import com.hzya.frame.voucher.ae.comf.subject.service.IAeConfSubjectContrastBService;
import com.hzya.frame.voucher.ae.comf.subject.service.IAeConfSubjectContrastService;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by zydd on 2025-05-30 15:13
 */
@RestController
@RequestMapping("/ae/conf/subjectContrastB")
public class ContrastBController extends DefaultController {

    @Autowired
    private IAeConfSubjectContrastService contrastService;
    @Autowired
    private IAeConfSubjectContrastBService contrastBService;

    @RequestMapping(value = "/queryAllByContrastId", method = RequestMethod.POST)
    public JsonResultEntity queryAllByContrastId(@RequestBody AeConfSubjectContrastBEntity entity){
        try {
            List<AeConfSubjectContrastBEntity> all = contrastBService.queryAllByContrastId(entity);
            return getSuccessMessageEntity("请求成功",all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/saveList", method = RequestMethod.POST)
    public JsonResultEntity saveList(@RequestBody List<AeConfSubjectContrastBEntity> list){
        try {
            List<AeConfSubjectContrastBEntity> all = contrastBService.saveListEntity(list);
            return getSuccessMessageEntity("请求成功",all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    @RequestMapping(value = "/updateList", method = RequestMethod.POST)
    public JsonResultEntity updateList(@RequestBody List<AeConfSubjectContrastBEntity> list){
        try {
            List<AeConfSubjectContrastBEntity> all = contrastBService.updateList(list);
            return getSuccessMessageEntity("请求成功",all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    @RequestMapping(value = "/delete", method = RequestMethod.POST)
    public JsonResultEntity delete(@RequestBody AeConfSubjectContrastBEntity entity){
        try {
            contrastBService.deleteList(entity);
            return getSuccessMessageEntity("请求成功",null);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
}
