package com.hzya.frame.voucher.ae.comf.subject.controller;

import com.hzya.frame.voucher.ae.comf.subject.entity.AeConfSubjectContrastEntity;
import com.hzya.frame.voucher.ae.comf.subject.service.IAeConfSubjectContrastService;
import com.hzya.frame.web.action.DefaultController;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by zydd on 2025-05-30 15:13
 */
@RestController
@RequestMapping("/ae/conf/subjectContrast")
public class ContrastController extends DefaultController {

    @Autowired
    private IAeConfSubjectContrastService aeConfSubjectContrastService;

    @RequestMapping(value = "/queryAll", method = RequestMethod.POST)
    public JsonResultEntity queryAll(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            List<AeConfSubjectContrastEntity> all = aeConfSubjectContrastService.queryAll(entity);
            return getSuccessMessageEntity("请求成功",all);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/queryById", method = RequestMethod.POST)
    public JsonResultEntity queryById(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            AeConfSubjectContrastEntity queryById = aeConfSubjectContrastService.queryById(entity);
            return getSuccessMessageEntity("请求成功",queryById);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    @RequestMapping(value = "/save", method = RequestMethod.POST)
    public JsonResultEntity save(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            AeConfSubjectContrastEntity save = aeConfSubjectContrastService.saveEntity(entity);
            return getSuccessMessageEntity("请求成功",save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public JsonResultEntity update(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            AeConfSubjectContrastEntity save = aeConfSubjectContrastService.updateEntity(entity);
            return getSuccessMessageEntity("请求成功",save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
    @RequestMapping(value = "/delete", method = RequestMethod.POST)
    public JsonResultEntity delete(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            AeConfSubjectContrastEntity save = aeConfSubjectContrastService.deleteEntity(entity);
            return getSuccessMessageEntity("请求成功",save);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }

    //1、根据入参影响因素ids，分别查询影响因素设置的对应基础档案类型
    //2、再按顺序拼接写类型的ids，再去科目对照表中查询这个ids对应的对照表
    //3、返回对照表对象
    @RequestMapping(value = "/queryByInfluenceIds", method = RequestMethod.POST)
    public JsonResultEntity queryByInfluenceIds(@RequestBody AeConfSubjectContrastEntity entity){
        try {
            AeConfSubjectContrastEntity aeConfSubjectContrastEntity = aeConfSubjectContrastService.queryByInfluenceIds(entity);
            return getSuccessMessageEntity("请求成功",aeConfSubjectContrastEntity);
        } catch (Exception e) {
            e.printStackTrace();
            return getFailureMessageEntity("请求失败",e.getMessage());
        }
    }
}
